/**********************************************************
             Mora Industrial MCU
        (c) Copyright by MORIB Sp. z o.o. 2001
        
============================================================

File: monitor.c

Contains: Debug monitor implementation

Remarks:       


Revision Control System
	$Id: template.c 1.2 1999/02/05 10:17:16 Rajish Exp $

         
***********************************************************/

#include <rtems.h>
#include <bspIo.h>

#define EXTERN
#include "monitor.h"

void monitor_dump_name(rtems_name name)
{
    char *c = (char *)&name;
    int i;
    
    for(i = 0; i < 4; i++)
        monitor_putchar(c[i]);
}

rtems_isr monitor_trapa(rtems_vector_number vector)
{
    printk("Trapa%d\r\n", vector);
}

rtems_status_code monitor_init()
{
    rtems_isr_entry old_isr;
    rtems_status_code result = RTEMS_SUCCESSFUL;
    
    result |= rtems_interrupt_catch(monitor_trapa, 4, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 6, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 9, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 10, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 11, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 12, &old_isr);


    result |= rtems_interrupt_catch(monitor_trapa, 32, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 33, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 34, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 35, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 36, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 37, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 38, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 39, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 40, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 41, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 42, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 43, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 44, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 45, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 46, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 47, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 48, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 49, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 50, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 51, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 52, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 53, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 54, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 55, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 56, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 57, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 58, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 59, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 60, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 61, &old_isr);
    result |= rtems_interrupt_catch(monitor_trapa, 62, &old_isr);
    return result |= rtems_interrupt_catch(monitor_trapa, 63, &old_isr);
}

extern void sh_sci_outbyte_polled(
  rtems_device_minor_number  minor,
  char ch );

void monitor_putchar(char c)
{
    if(c == '\n')
        sh_sci_outbyte_polled(0, '\r');
    sh_sci_outbyte_polled(0, c);
}


BSP_output_char_function_type BSP_output_char = monitor_putchar;

rtems_extension monitor_task_create(rtems_tcb *current_task, rtems_tcb *new_task)
{
    printk("tc[");
}

rtems_extension monitor_task_start(rtems_tcb *current_task, rtems_tcb *started_task )
{
    printk("ts(");
}

rtems_extension monitor_task_restart( rtems_tcb *current_task, rtems_tcb *restarted_task )
{
    printk("tr");
}

rtems_extension monitor_task_delete( rtems_tcb *current_task, rtems_tcb *deleted_task )
{
    printk("]td\n");
}

#define bs "\x08"

unsigned long get_sp()
{
    register unsigned long ret;
    asm ("mov r15, %0":"=r"(ret));
    return ret;
}


rtems_extension monitor_task_switch( rtems_tcb *current_task, rtems_tcb *heir_task )
{
/*     static int i = 0; */
    printk("<<s:%X p:", get_sp());
    monitor_dump_name(*((rtems_name*)current_task->Object.name));
    printk(" st: %X", current_task->current_state);
    printk(" n:");
    monitor_dump_name(*((rtems_name*)heir_task->Object.name));
    printk(" st: %X", heir_task->current_state);
    printk(">>\n");
    
/*     switch(i) */
/*     { */
/*     case 0: */
/*         printk("\\"); */
/*         break; */
/*     case 1: */
/*         printk(bs); */
/*         break; */
/*     case 2: */
/*         printk("|"); */
/*         break; */
/*     case 3: */
/*         printk(bs); */
/*         break; */
/*     case 4: */
/*         printk("/"); */
/*         break; */
/*     case 5: */
/*         printk(bs); */
/*         break; */
/*     case 6: */
/*         printk("-"); */
/*         break; */
/*     case 7: */
/*         printk(bs); */
/*         break; */
/*     } */
/*     i++; */
/*     if(i > 7) */
/*         i = 0; */
}

rtems_extension monitor_task_begin( rtems_tcb *current_task )
{
    printk("tb<<");
    monitor_dump_name(*((rtems_name*)current_task->Object.name));
    printk(" sp: %X>>\n", get_sp());
}

rtems_extension monitor_task_exitted( rtems_tcb *current_task )
{
    printk(">te");
}

rtems_extension monitor_fatal_error( Internal_errors_Source the_source, 
                                     rtems_boolean is_internal, 
                                     rtems_unsigned32 the_error )
{
    printk("Fatal error\n");
}



