/**********************************************************
             Mora Industrial MCU
        (c) Copyright by MORIB Sp. z o.o. 2001
        
============================================================

File: monitor.h

Contains: Debug monitor declarations

Remarks:       


Revision Control System
	$Id: template.h 1.1 1999/02/03 16:26:51 Rajish Exp $

         
***********************************************************/

#ifndef _MONITOR_H_
#define _MONITOR_H_

#include <rtems.h>

rtems_status_code monitor_init();
void monitor_dump_name(rtems_name name);
void monitor_putchar(char c);

rtems_extension monitor_task_create(rtems_tcb *current_task, rtems_tcb *new_task);
rtems_extension monitor_task_start(rtems_tcb *current_task, rtems_tcb *started_task );
rtems_extension monitor_task_restart( rtems_tcb *current_task, rtems_tcb *restarted_task );
rtems_extension monitor_task_delete( rtems_tcb *current_task, rtems_tcb *deleted_task );
rtems_extension monitor_task_switch( rtems_tcb *current_task, rtems_tcb *heir_task );
rtems_extension monitor_task_begin( rtems_tcb *current_task );
rtems_extension monitor_task_exitted( rtems_tcb *current_task );
rtems_extension monitor_fatal_error( Internal_errors_Source the_source, 
                                     rtems_boolean is_internal, 
                                     rtems_unsigned32 the_error );


#ifndef EXTERN
#define EXTERN extern
#endif

/* #define MY_MONITOR_EXTENSIONS_TABLE             \ */
/* {                                               \ */
/*     monitor_task_create,                        \ */
/*     monitor_task_start,                         \ */
/*     monitor_task_restart,                       \ */
/*     monitor_task_delete,                        \ */
/*     monitor_task_switch,                        \ */
/*     monitor_task_begin,                         \ */
/*     monitor_task_exitted,                       \ */
/*     monitor_fatal_error                         \ */
/* } */

#define MY_MONITOR_EXTENSIONS_TABLE             \
{                                               \
    0,                                          \
    0,                                          \
    0,                                          \
    0,                                          \
    monitor_task_switch,                        \
    0,                                          \
    0,                                          \
    monitor_fatal_error                         \
}


#undef EXTERN

#endif /* _MONITOR_H_ */

