/*  system.h
 *
 *  This include file contains information that is included in every
 *  function in the test set.
 *
 *  $Id: system.h,v 1.12.2.4 2000/05/24 17:06:40 joel Exp $
 */

#include <rtems.h>

/* functions */

rtems_task Init(rtems_task_argument argument);


/* global variables */

/*
 *  Keep the names and IDs in global variables so another task can use them.
 */ 

extern rtems_id   Task_id[ 4 ];         /* array of task ids */
extern rtems_name Task_name[ 4 ];       /* array of task names */


/* configuration information */

#include <bsp.h> /* for device driver prototypes */

/* These defs are replaced by our own declaration of drivers table */
#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER
#define CONFIGURE_APPLICATION_NEEDS_CLOCK_DRIVER

#define CONFIGURE_MAXIMUM_TASKS             4

#define CONFIGURE_RTEMS_INIT_TASKS_TABLE

#define CONFIGURE_EXTRA_TASK_STACKS         (3 * RTEMS_MINIMUM_STACK_SIZE)

/* Need some custom drivers and don't want to mess up the bsp */
#define CONFIGURE_HAS_OWN_DEVICE_DRIVER_TABLE
#if (defined CONFIGURE_INIT) && (defined CONFIGURE_HAS_OWN_DEVICE_DRIVER_TABLE)
rtems_driver_address_table Device_drivers[] = {
  CONSOLE_DRIVER_TABLE_ENTRY,
  MY_CLOCK_DRIVER_TABLE_ENTRY,
};
#endif /* CONFIGURE_INIT && CONFIGURE_HAS_OWN_DEVICE_DRIVER_TABLE*/

/* #define CONFIGURE_MICROSECONDS_PER_TICK 5000 */

/* #define STACK_CHECK_ON */

/* #define CONFIGURE_MAXIMUM_USER_EXTENSIONS 1 */
#define CONFIGURE_INITIAL_EXTENSIONS MY_MONITOR_EXTENSIONS_TABLE

#include <confdefs.h>


/* end of include file */
